Package org.jboss.logging.processor.model

## Interface DelegatingElement

All Superinterfaces:
  `AnnotatedConstruct`, `Element`

All Known Subinterfaces:
  `DelegatingExecutableElement`, `DelegatingTypeElement`, `MessageInterface`, `MessageMethod`, `Parameter`, `ReturnType`, `ThrowableType`

    public interface DelegatingElement
    extends Element

A delegating `Element` interface. All methods are invoked on the delegate element by default.

Author:
  James R. Perkins

### Method Summary

All Methods Instance Methods Abstract Methods Default Methods
`default <R,P> R` `accept​(ElementVisitor<R,P> v, P p)`
`default TypeMirror` `asType​()`
`default <A extends Annotation> A` `getAnnotation​(Class<A> annotationType)`
`default List<? extends AnnotationMirror>` `getAnnotationMirrors​()`
`default <A extends Annotation> A[]` `getAnnotationsByType​(Class<A> annotationType)`
`Element` `getDelegate​()` The element to delegate the default methods to.
`default List<? extends Element>` `getEnclosedElements​()`
`default Element` `getEnclosingElement​()`
`default ElementKind` `getKind​()`
`default Set<Modifier>` `getModifiers​()`
`default Name` `getSimpleName​()`
`default boolean` `isAnnotatedWith​(Class<? extends Annotation> annotation)` Checks whether or not the annotation is present on the element.

### Methods inherited from interface javax.lang.model.element.Element

`equals, hashCode`

### Method Detail

#### getDelegate

    Element getDelegate​()

The element to delegate the default methods to.

Returns:
  the delegate

#### asType

    default TypeMirror asType​()

Specified by:
  `asType` in interface `Element`

#### getKind

    default ElementKind getKind​()

Specified by:
  `getKind` in interface `Element`

#### getModifiers

    default Set<Modifier> getModifiers​()

Specified by:
  `getModifiers` in interface `Element`

#### getSimpleName

    default Name getSimpleName​()

Specified by:
  `getSimpleName` in interface `Element`

#### getEnclosingElement

    default Element getEnclosingElement​()

Specified by:
  `getEnclosingElement` in interface `Element`

#### getEnclosedElements

    default List<? extends Element> getEnclosedElements​()

Specified by:
  `getEnclosedElements` in interface `Element`

#### getAnnotation

    default <A extends Annotation> A getAnnotation​(Class<A> annotationType)

Specified by:
  `getAnnotation` in interface `AnnotatedConstruct`
Specified by:
  `getAnnotation` in interface `Element`

#### getAnnotationMirrors

    default List<? extends AnnotationMirror> getAnnotationMirrors​()

Specified by:
  `getAnnotationMirrors` in interface `AnnotatedConstruct`
Specified by:
  `getAnnotationMirrors` in interface `Element`

#### accept

    default <R,P> R accept​(ElementVisitor<R,P> v,
                           P p)

Specified by:
  `accept` in interface `Element`

#### getAnnotationsByType

    default <A extends Annotation> A[] getAnnotationsByType​(Class<A> annotationType)

Specified by:
  `getAnnotationsByType` in interface `AnnotatedConstruct`

#### isAnnotatedWith

    default boolean isAnnotatedWith​(Class<? extends Annotation> annotation)

Checks whether or not the annotation is present on the element.

Parameters:
  `annotation` - the annotation to check for
Returns:
  `true` if the annotation is present, otherwise `false`